;----------------------------------------------------------------------------
;File name:	URAn_ERR.SH			Revision date:	1998.08.11
;Creator:	Ulf Ronald Andersson		Creation date:	1997.01.02
;(c)1997 by:	Ulf Ronald Andersson		All rights reserved
;Released as:	FREEWARE			(commercial sale forbidden)
;----------------------------------------------------------------------------
;Purpose:	Defines error codes for TOS functions
;----------------------------------------------------------------------------
;NB:	System error messages were badly defined by Atari to have a prefix
;	simply consisting of the letter 'E', which makes mixups inevitable.
;	Using underscore at prefix end would make this 'E_', but this is used
;       by many packages for proprietary error messages, since Atari had left
;	them 'free'.  I have therefore redefined the system error messages to
;	use a prefix of 'E~' to make them clearly distinguishable.
;
;	eg: Use E~OK, E~NOMEM, E~ACCESS, instead of EOK, ENOMEM, EACCESS.
;----------------------------------------------------------------------------
;	Error code definitions
;
E~OK		equ	  0
E~ERROR		equ	 -1
E~IO		equ	E~ERROR
E~DRVNR		equ	 -2
E~UNCMD		equ	 -3
E~CRC		equ	 -4
E~BADRQ		equ	 -5
E~SEEK		equ	 -6
E~MEDIA		equ	 -7
E~SECNF		equ	 -8
E~PAPER		equ	 -9
E~WRITF		equ	-10
E~READF		equ	-11
E~GENRL		equ	-12
E~WRPRO		equ	-13
E~CHNG		equ	-14
E~AGAIN		equ	E~CHNG
E~UNDEV		equ	-15
E~BADSF		equ	-16
E~OTHER		equ	-17
E~INSERT	equ	-18
E~DEVNRSP	equ	-19
;
;	--------
;
E~INVFN		equ	-32
E~FILNF		equ	-33
E~NOENT		equ	E~FILNF
E~RSCH		equ	E~FILNF
E~PTHNF		equ	-34
E~NOTDIR	equ	E~PTHNF
E~NHNDL		equ	-35
E~ACCDN		equ	-36
E~ACCESS	equ	E~ACCDN
E~EXIST		equ	E~ACCDN
E~IHNDL		equ	-37
; ???		equ	-38
E~NSMEM		equ	-39
E~NOMEM		equ	E~NSMEM
E~IMBA		equ	-40
; ???		equ	-41
E~DFULL		equ	-42
; ???		equ	-43
; ???		equ	-44
; ???		equ	-45
E~DRIVE		equ	-46
; ???		equ	-47
E~NSAME		equ	-48
E~NMFIL		equ	-49
; ???		equ	-50
; ???		equ	-51
; ???		equ	-52
; ???		equ	-53
; ???		equ	-54
; ???		equ	-55
; ???		equ	-56
; ???		equ	-57
E~RLCKD		equ	-58
E~LOCK		equ	E~RLCKD
E~LOCKED	equ	E~RLCKD
E~MLNF		equ	-59
E~NSLOCK	equ	E~MLNF
; ???		equ	-60
; ???		equ	-61
; ???		equ	-62
; ???		equ	-63
E~RANGE		equ	-64
E~NAMETOOLONG	equ	E~RANGE
E~INTRN		equ	-65
E~PLFMT		equ	-66
E~NOEXEC	equ	E~PLFMT
E~GSBF		equ	-67
E~BREAK		equ	-68
E~XCPT		equ	-69	;MagiC
E~PTHOV		equ	-70
;
;	--------
;
E~LOOP		equ	-80
E~MOUNT		equ	-200
;----------------------------------------------------------------------------
;End of file:	URAn_ERR.SH
;----------------------------------------------------------------------------
